package com.mes.pp.controller;


import com.mes.pp.entity.OptimizeProject;
import com.mes.pp.entity.request.OptimizeRequest;
import com.mes.pp.service.OptimizeProjectService;
import com.mes.utils.Result;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author zhoush
 * @since 2024-04-16
 */
@RestController
@RequestMapping("/optimizeProject")
@Slf4j

public class OptimizeProjectController {
    @Autowired
    //获取待选择的工程号
    private OptimizeProjectService optimizeProjectService;

    @ApiOperation("显示工程选择信息")
    @PostMapping("/listByState") //显示工程选择信息
    public Result<List<OptimizeProject>> listByState(@RequestBody OptimizeRequest optimizeRequest) {
        log.info("将请求参数封装在请求类里面");
        List<OptimizeProject> glass = optimizeProjectService.listByState(optimizeRequest);
        log.info("显示工程选择信息:{}", glass);
        return Result.build(200, "", glass);
    }

    @ApiOperation("保存工程信息")
    @PostMapping("/saveProject") //显示工程选择信息
    public Result<List<OptimizeProject>> saveProject(@RequestBody OptimizeRequest optimizeRequest) {
        log.info("获取选择好的工程id进行查询数据后保存");
        List<OptimizeProject> glass = optimizeProjectService.selectSaveProject(optimizeRequest);
        log.info("显示工程选择信息后保存到upPattenUsage表:{}", glass);
        optimizeProjectService.insetupPattenUsage(glass);
        //void insetProject(glass);
        return Result.build(200, "", glass);
    }

}

