package com.mes.pp.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 *
 * </p>
 *
 * @author zhoush
 * @since 2024-04-16
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class OptimizeProject implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 自增：<优化-工程>
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 工程编号
     */
    private String projectNo;

    /**
     * 工程项目名
     */
    private String projectName;

    /**
     * 玻璃膜系
     */
    private String glassType;

    /**
     * 玻璃厚度
     */
    private String glassThickness;

    /**
     * 工程种类
     */
    private Integer type;

    /**
     * 状态：	-2删除；	-1默认；		1流程卡创建；	2第一次优化保存;		10钢化推荐创建保存；	20优化结果保存
     */
    private Integer state;

    /**
     * 总数
     */
    private Integer glassTotal;

    /**
     * 总面积
     */
    private Double glassTotalArea;

    /**
     * 流程卡数量
     */
    private Integer processQty;

    /**
     * 循环落架数
     */
    private Integer guidance;

    /**
     * 第一次使用原料数
     */
    private Integer fristStockQty;

    /**
     * 第一次平均切裁率
     */
    private String fristCutPct;

    /**
     * 使用的原料数
     */
    private Integer rawStockQty;

    /**
     * 使用的原料面积
     */
    private String rawStockArea;

    /**
     * 平均切裁率
     */
    private String avgCutPct;

    /**
     * 有效切裁率
     */
    private String validCutPct;

    /**
     * 尾片切裁率
     */
    private String lastCutPct;

    /**
     * g混排程度
     */
    private String chaosPct;

    /**
     * g最大装载率
     */
    private String maxLoadPct;

    /**
     * g最大面积
     */
    private String maxArea;

    /**
     * g最大数量
     */
    private Integer maxQty;

    /**
     * g上片宽
     */
    private Float loadWidth;

    /**
     * g上片长
     */
    private Float loadLength;

    /**
     * x间隔
     */
    private Float xSpace;

    /**
     * y间隔
     */
    private Float ySpace;

    /**
     * g平均装载率
     */
    private Float loadRate;

    /**
     * 流程卡集合
     */
    private String processCards;

    /**
     * g总炉数
     */
    private Integer furnacesQty;

    /**
     * 备注
     */
    private String remark;

    /**
     * 创建人
     */
    private String creater;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 修改时间
     */
    private Date updateTime;

    /**
     * 预留，使用需注明
     */
    @TableField("intRemark")
    private Integer intremark;

    /**
     * 预留，使用需注明
     */
    @TableField("strRemark")
    private String strremark;


}
