package com.mes.pp.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.github.yulichang.base.MPJBaseServiceImpl;
import com.mes.pp.entity.OptimizeProject;
import com.mes.pp.entity.request.OptimizeRequest;
import com.mes.pp.mapper.OptimizeProjectMapper;
import com.mes.pp.service.OptimizeProjectService;
import com.mes.uppattenusage.entity.UpPattenUsage;
import com.mes.uppattenusage.mapper.UpPattenUsageMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author zhoush
 * @since 2024-04-16
 */
@Service
@DS("pp")
@Slf4j
public class OptimizeProjectServiceImpl extends MPJBaseServiceImpl<OptimizeProjectMapper, OptimizeProject> implements OptimizeProjectService {

    @Resource
    UpPattenUsageMapper upPattenUsageMapper;
    @Override
    public List<OptimizeProject> listByState(OptimizeRequest optimizeRequest) {
        log.info("将参数传入到查询类里,工程号做非空判断模糊查询");
        LambdaQueryWrapper<OptimizeProject> wrapper = new LambdaQueryWrapper<>();
        wrapper.eq(OptimizeProject::getState,optimizeRequest.getState())
                .like(StringUtils.isNotBlank(optimizeRequest.getProjectNo()),OptimizeProject::getProjectNo,optimizeRequest.getProjectNo())
                //.groupBy(OptimizeProject::getProjectNo)
        ;
        log.info("返回工程信息");
        return this.list(wrapper);
    }


    @Override
    public void insetupPattenUsage(List<OptimizeProject> glass) {
        log.info("循环查询结果保存到UpPattenUsage表中");
        for (OptimizeProject project : glass) {
            UpPattenUsage upPattenUsage = new UpPattenUsage();
            upPattenUsage.setEngineeringId(project.getProjectNo());
            upPattenUsage.setFilmsId(project.getGlassType());
            upPattenUsage.setState(project.getState());
            upPattenUsageMapper.insert(upPattenUsage);
        }
    }

    @Override
    public List<OptimizeProject> selectSaveProject(OptimizeRequest optimizeRequest) {
        log.info("将参数传入到查询类里,工程号做非空判断模糊查询");

        log.info("返回工程信息");
        return this.baseMapper.saveProject(optimizeRequest);
    }

}
