package com.mes.edgstoragecage.controller;

import com.mes.edgstoragecage.entity.EdgStorageCage;
import com.mes.edgstoragecage.service.EdgStorageCageService;
import com.mes.edgstoragecage.service.impl.EdgStorageCageServiceImpl;
import com.mes.taskcache.entity.TaskCache;
import com.mes.taskcache.service.impl.TaskCacheServiceImpl;
import com.mes.utils.Result;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.awt.image.ImageProducer;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zhoush
 * @since 2024-04-07
 */
@RestController
@RequestMapping("/edgStorageCage")
public class EdgStorageCageController {

    @Autowired
    private EdgStorageCageServiceImpl edgStorageCageServiceImpl;


    //查询磨边缓存理片笼内详情
    @PostMapping("/selectEdgStorageCage")
    @ResponseBody
    public Result selectEdgStorageCage () {
        List<Map> list=edgStorageCageServiceImpl.selectEdgStorageCages();
        return Result.build(200,"成功",list);
    }
    //添加磨边缓存理片笼信息   功能：笼内绑定玻璃
    @PostMapping("/insertEdgStorageCage")
    @ResponseBody
    public Result insertEdgStorageCage(@RequestBody EdgStorageCage edgStorageCage) {
        boolean isSucess=edgStorageCageServiceImpl.updateEdgStorageCage(edgStorageCage);
        return Result.build(200,"添加成功",1);
    }
    //修改磨边缓存理片笼信息   功能：对笼内栅格进行【启用/禁用】/ 【更换】笼内栅格玻璃信息
    @PostMapping("/updateEdgStorageCage")
    @ResponseBody
    public Result updateEdgStorageCage(@RequestBody EdgStorageCage edgStorageCage) {
        boolean isSucess=edgStorageCageServiceImpl.updateEdgStorageCage(edgStorageCage);
        return Result.build(200,"更换成功",1);
    }

    //删除磨边缓存理片笼信息   功能：对笼内栅格玻璃进行【清除】
    @PostMapping("/deleteEdgStorageCage")
    @ResponseBody
    public Result deleteEdgStorageCage(@RequestBody EdgStorageCage edgStorageCage) {
        boolean isSucess=edgStorageCageServiceImpl.updateEdgStorageCage(edgStorageCage);
        return Result.build(200,"删除成功",1);
    }

}

