package com.mes.glassinfo.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.mes.glassinfo.entity.GlassInfo;
import com.mes.glassinfo.mapper.GlassInfoMapper;
import com.mes.glassinfo.service.GlassInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zhoush
 * @since 2024-04-07
 */
@Service
public class GlassInfoServiceImpl extends ServiceImpl<GlassInfoMapper, GlassInfo> implements GlassInfoService {

    @Autowired
    GlassInfoMapper glassInfoMapper;

    //根据ID 获取小片数据
    @Override
    public List<GlassInfo> selectId(String glassId){
        return glassInfoMapper.selectList(new QueryWrapper<GlassInfo>().eq("id",glassId));
    };

    //获取全部小片数据
    @Override
    public List<GlassInfo> selectAll(){
        return glassInfoMapper.selectList(null);
    };

    //根据工程 获取小片数据
    @Override
    public List<GlassInfo> selectFlowCardId(String flowCardId){
        return glassInfoMapper.selectList(new QueryWrapper<GlassInfo>().eq("flowCardId",flowCardId));
    };
}
