package com.mes.taskcache.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.mes.glassinfo.entity.GlassInfo;
import com.mes.glassinfo.mapper.GlassInfoMapper;
import com.mes.taskcache.entity.TaskCache;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.mes.taskcache.mapper.TaskCacheMapper;
import com.mes.taskcache.service.TaskCacheService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zhoush
 * @since 2024-04-07
 */
@Service
public class TaskCacheServiceImpl extends ServiceImpl<TaskCacheMapper, TaskCache> implements TaskCacheService {

    @Autowired
    GlassInfoMapper glassInfoMapper;
    @Autowired
    TaskCacheMapper taskCacheMapper;
    //添加理片笼任务
    @Override
    public boolean insertTaskCache(TaskCache taskCache){
        taskCacheMapper.insert(taskCache);
        return true;
    }
    //查询磨边任务
    @Override
    public List<TaskCache> selectEdgInfo(String line) {
        return taskCacheMapper.selectList(new QueryWrapper<TaskCache>().eq("endcell",line));
    }
    //查询待理片工作的任务
    @Override
    public List<TaskCache> selectCacheInfo(){
        return taskCacheMapper.selectList(new QueryWrapper<TaskCache>().eq("taskstauts",0));
    }
    //查询全部任务
    @Override
    public List<TaskCache> selectAll() {
        return taskCacheMapper.selectList(null);
    }
    //查询待进片任务
    @Override
    public List<TaskCache> selectInputTaskCache(){
        return taskCacheMapper.selectList(new QueryWrapper<TaskCache>().eq("taskstauts",0).eq("tasktype",1));
    }

    //查询待出片任务
    @Override
    public List<TaskCache> selectOutTaskCache(){
        return taskCacheMapper.selectList(new QueryWrapper<TaskCache>().eq("taskstauts",0).eq("tasktype",2));
    }

    //查询  A09  或 A10 最新的一片 出片任务
    @Override
    public List<TaskCache> selectLastOutCacheInfo(String line){
        return taskCacheMapper.selectList(new QueryWrapper<TaskCache>().eq("endcell",line).eq("taskstauts",1).orderByDesc("ID"));
    }
}
