package com.mes.bigstoragetask.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.mes.bigstorage.entity.BigStorageCageDetails;
import com.mes.bigstoragetask.entity.BigStorageCageFeedTask;
import com.mes.bigstoragetask.entity.BigStorageCageOutTask;
import com.mes.bigstoragetask.mapper.BigStorageCageFeedTaskMapper;
import com.mes.bigstoragetask.service.BigStorageCageFeedTaskService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import net.bytebuddy.matcher.FilterableList;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zhoush
 * @since 2024-04-16
 */
@Service
public class BigStorageCageFeedTaskServiceImpl extends ServiceImpl<BigStorageCageFeedTaskMapper, BigStorageCageFeedTask> implements BigStorageCageFeedTaskService {

    @Override
    public void addFeedTask(BigStorageCageDetails slotInfo, Integer plcFeedReqLine, int taskType){
        BigStorageCageFeedTask bigStorageCageFeedTask=new BigStorageCageFeedTask();
        bigStorageCageFeedTask.setId(slotInfo.getId());
        bigStorageCageFeedTask.setTaskState(0);
        bigStorageCageFeedTask.setLine(plcFeedReqLine);
        bigStorageCageFeedTask.setTragetSlot(slotInfo.getSlot());
        bigStorageCageFeedTask.setTaskType(taskType);
        baseMapper.insert(bigStorageCageFeedTask);
    }

    @Override
    public List<BigStorageCageFeedTask> querybigStorageCageFeedTask(int taskState){
        LambdaQueryWrapper<BigStorageCageFeedTask> getFeedTaskWrapper=new LambdaQueryWrapper<>();
        getFeedTaskWrapper.eq(BigStorageCageFeedTask::getTaskState,1);
        return baseMapper.selectList(getFeedTaskWrapper);
    }
}
