package com.mes.workstation.controller;


import com.mes.utils.Result;
import com.mes.workstation.entity.GlassInfo;
import com.mes.workstation.entity.UpWorkstation;
import com.mes.workstation.service.UpWorkstationService;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author zhoush
 * @since 2024-04-07
 */
@RestController
@RequestMapping("/LoadGlass")
@Slf4j
public class UpWorkstationController {
    @Autowired
    private UpWorkstationService upWorkstationService;
    private GlassInfo glassInfo;
    @ApiOperation("显示工位上的玻璃信息")
    @GetMapping("/list") //查询现在上片机的玻璃信息
    public Result<List<UpWorkstation>> list() {
        List<UpWorkstation> glass = upWorkstationService.list();
        log.info("显示工位上的玻璃信息:{}", glass);
        return Result.build(200, "", glass);
    }

    //新增工位信息修改一条工位信息,接收实例类字段为宽高厚膜系数量工位id
    //删除工位信息也用这个,除了工位id玻璃信息传null
    @ApiOperation("修改工位表增加玻璃信息或者删除玻璃信息,传递Upworkstation类,只修改宽高厚数量膜系")
    @PostMapping("/updateGlassMessage")
    @ResponseBody
    public void updateGlassMessage(@RequestBody UpWorkstation upwork) {
        upWorkstationService.updateGlassMessage(upwork);
    }

    @ApiOperation("开始上片任务")
    @PostMapping("/selectPriority") //开始上片任务
    @ResponseBody
    public void selectPriority() {
        upWorkstationService.selectPriority();
    }
}

