package com.mes.temperingglass.service;
//import com.mes.temperingglass.entity.GlassInfo;

import com.mes.temperingglass.entity.TemperingGlassInfo;
import com.mes.temperingglass.mapper.TemperingMapper;
import com.mes.tools.S7control;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class TemperingService {

    private final TemperingMapper temperingMapper;
    private S7control s7control;

    public TemperingService(TemperingMapper temperingMapper) {
        this.temperingMapper = temperingMapper;
    }

    //    //接收id返回坐标和数据
//    public GlassInfo SelectOutGlass (String glassid) {
//        GlassInfo GlassInfo = temperingMapper.SelectGlass(glassid);
//        return GlassInfo;
//    }
    //发送坐标信息
    public void SendCoordinate(short glassX, short glassY) {
        s7control.WriteWord("DB100.10", glassX);
        s7control.WriteWord("DB100.10", glassY);
    }

    //判断是否可以发送进炉信号
    public int SelectTempering(String glassid) {
        int tempering = temperingMapper.SelectTempering(glassid);
        if (tempering == 1) {
            return 1;
        } else {
            return 0;
        }
    }

    //发送进炉信号
    public void SendIntoGlass(short start) {
        s7control.WriteWord("DB100.10", start);
    }

    //接受完成字回复确认字
    public void SendIntoGlass() {
        s7control.WriteWord("DB100.10", (short) 1);
    }

    //显示等待中的版图
    public List<TemperingGlassInfo> SelectWaitingGlass() {
        List<TemperingGlassInfo> WaitingGlass = temperingMapper.SelectWaitingGlass();
        return WaitingGlass;
    }

    //显示正在进炉的版图
    public List<TemperingGlassInfo> SelectIntoGlass() {
        List<TemperingGlassInfo> IntoGlass = temperingMapper.SelectInGlass();
        return IntoGlass;
    }
}
