package com.mes.downglassinfo.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.mes.downglassinfo.entity.DownGlassInfo;
import com.mes.downglassinfo.mapper.DownGlassInfoMapper;
import com.mes.downglassinfo.service.DownGlassInfoService;
import org.springframework.stereotype.Service;

@Service
public class DownGlassInfoServiceImpl extends ServiceImpl<DownGlassInfoMapper, DownGlassInfo> implements DownGlassInfoService {

    // 根据流程卡号查询最大序号
    @Override
    public Integer getMaxSequenceByFlowCardId(String flowCardId) {
        QueryWrapper<DownGlassInfo> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("flow_card_id", flowCardId);
        queryWrapper.orderByDesc("sequence"); // 按照序号倒序排序
        queryWrapper.select("sequence").last("LIMIT 1"); // 选择最大序号并限制结果为1条记录
        DownGlassInfo downGlassInfo = baseMapper.selectOne(queryWrapper);
        if (downGlassInfo != null) {
            return downGlassInfo.getSequence();
        }
        return 0;
    }

    @Override
    public void insertDownGlassInfo(DownGlassInfo downGlassInfo) {
        baseMapper.insert(downGlassInfo);
    }


}
