package com.mes.downglassinfo.service.impl;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.mes.downglassinfo.entity.DownGlassTask;
import com.mes.downglassinfo.mapper.DownGlassTaskMapper;
import com.mes.downglassinfo.service.DownGlassTaskService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author zhoush
 * @since 2024-04-07
 */
@Service
public class DownGlassTaskServiceImpl extends ServiceImpl<DownGlassTaskMapper, DownGlassTask> implements DownGlassTaskService {


    @Override
    public List<DownGlassTask> getUnloadingTaskState() {
        QueryWrapper<DownGlassTask> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("task_stauts", 1);
        return baseMapper.selectList(queryWrapper);
    }

    @Override
    public void updateTaskStateToZero(String flowCardId) {
        UpdateWrapper<DownGlassTask> updateWrapper = new UpdateWrapper<>();
        updateWrapper.set("task_stauts", 0).eq("flow_card_id", flowCardId);
        baseMapper.update(null, updateWrapper);
    }

    @Override
    public void deleteTask(String flowCardId) {
        LambdaQueryWrapper<DownGlassTask> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(DownGlassTask::getFlowCardId, flowCardId);

        baseMapper.delete(queryWrapper);
    }

    @Override
    public DownGlassTask selectLastOutCacheInfo(String endCell) {
        QueryWrapper<DownGlassTask> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("task_type", "2")
                .eq("task_status", "2")
                .eq("end_cell", endCell)
                .last("LIMIT 1");

        return baseMapper.selectOne(queryWrapper);
    }

    @Override
    public Integer insertCacheTask(Long id, String start, String end, String type, double width, double height, String filmsId, double thickness, String flowCardId) {
        DownGlassTask glassInfo = new DownGlassTask();
        glassInfo.setId(id);
        glassInfo.setStartCell(start);
        glassInfo.setEndCell(end);
        glassInfo.setTaskType(type);
        glassInfo.setWidth(width);
        glassInfo.setHeight(height);
        glassInfo.setFilmsid(filmsId);
        glassInfo.setThickness(thickness);
        glassInfo.setFlowCardId(flowCardId);
        glassInfo.setTaskStauts(0); // 默认任务状态为0

        int rows = baseMapper.insert(glassInfo);
        return rows > 0 ? rows : null;
    }


}
