package com.mes.downworkstation.service.impl;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.mes.downglassinfo.entity.DownGlassInfo;
import com.mes.downworkstation.entity.DownWorkstationTask;
import com.mes.downworkstation.mapper.DownWorkstationTaskMapper;
import com.mes.downworkstation.service.DownWorkstationTaskService;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author zhoush
 * @since 2024-04-07
 */
@Service
public class DownWorkstationTaskServiceImpl extends ServiceImpl<DownWorkstationTaskMapper, DownWorkstationTask> implements DownWorkstationTaskService {


    public void insertdownWorkstationtask(DownGlassInfo downGlassInfo) {
        DownWorkstationTask entity = new DownWorkstationTask();
        entity.setFlowCardId(downGlassInfo.getFlowCardId());
        entity.setWidth(downGlassInfo.getWidth());
        entity.setHeight(downGlassInfo.getHeight());
        entity.setThickness(downGlassInfo.getThickness());
        entity.setFilmsid(downGlassInfo.getFilmsid());
        entity.setState(1);

        baseMapper.insert(entity);
    }

    @Override
    public void updateTaskStateToZero(String flowCardId) {
        UpdateWrapper<DownWorkstationTask> updateWrapper = new UpdateWrapper<>();
        updateWrapper.set("state", 0).eq("flow_card_id", flowCardId);

        baseMapper.update(null, updateWrapper);
    }
}
